var sgSdk = function () {

  var config;

  function initialize(moduleArray, _config, callBack) {
    config = _config;
    var settings = {
      config: {
        rewarded: {
          enabled: true
        },
        env: {
          locale: "en"
        }
      }
    };
    callBack(null, settings, sgSdk);
  }

  function trigger(key, data) {
    switch (key) {
      case "restore":
        restore(data);
        break;

      case "loading.completed":
        loadingComplete(data);
        break;

      case "loading.update":
        loadingUpdate(data);
        break;

      case "levelStart":
        levelStart(data);
        break;

      case "gameTracking":
      case "start":
      case "levelFinish":
        nothing(data);
        break;

      case "save":
        save(data);
        break;

      case "beforePlayButtonDisplay":
      case "playButtonPressed":
        callbackCall(data);
        break;

      case "rewardedAd":
        rewardedAd(data);
        break;

      default:
        break;
    }
  }

  function nothing(data) {
    console.log("LEVEL FINISH", data);
    // we dont use this data for now
   };

  function restore(data) {
    var item = localStorage.getItem(data.key);

    data.callback(null, item);
  }

  async function loadingComplete(data) {
    var userData = { id: "100" };

    data.callback(null, userData);
    G.runGame();
  }

  function loadingUpdate(data) {
    // we dont use this data for now
  }

  function levelStart(data) {
    console.log("LEVEL START", data);
    // we dont use this data for now
  }

  function save(data) {
    localStorage.setItem(data.key, data.value);

    data.callback();
  }

  function callbackCall(data) {
    data.callback();
  }

  function rewardedAd(data) {
    var success = Math.random() > 0.25;

    data.callback(success);
  }

  return {
    initialize: initialize,
    trigger: trigger,
    GA: {
      GameAnalytics: {
        setCustomDimension01: nothing,
        addDesignEvent: nothing,
      }
    }
  }

}();